/*
A Demonstration of the Turn Library
Author: Dan (dan@dantom.com)

This number guessing game starts by creating a turn generator, adding
players to it as they log in, and taking guesses from them when it becomes
their turn.  Everyone gets too see a player's guess, but only the player
gets information about whether it was too big or too small.
*/

#include <Dan/TakeTurns>   //ensure this is included first since we override /Turn procs

var/TakeTurns/trn = new()  //create a turn generator
var/secret                 //this is the secret number

proc/StartGame()
	secret = rand(1,1000)   //pick a random number between 1 and 1000

//This is called by the turn generator whenever it becomes a player's turn.
TakeTurns/BeginTurn()
	var/N = input("Enter Your Guess (1 - 1000)") as num|null
	if(N==null) 
		del usr
		return

	world << "[usr] guesses [N]."
	if(N < secret) usr << "Too small."
	if(N > secret) usr << "Too big."
	if(N == secret)
		world << "[usr] guessed the secret number!"
		StartGame()

	trn.NextTurn() //tell the turn generator to move on to the next player

mob/Login()
	world << "[usr] logs in."
	if(!length(trn.players)) StartGame()
	trn.AddPlayer(src)
	return ..()

mob/Logout()
	world << "[usr] logs out."
	trn.DelPlayer(src)
	return ..()
